Namespaces
Variants
Views
Actions

std::promise::set_exception

From cppreference.com
< cpp‎ | thread‎ | promise
Revision as of 18:32, 9 July 2013 by P12bot (Talk | contribs)

 
 
Thread support library
Threads
(C++11)
this_thread namespace
(C++11)
(C++11)
(C++11)
Mutual exclusion
(C++11)
Generic lock management
(C++11)
(C++11)
(C++11)
(C++11)(C++11)(C++11)
(C++11)
(C++11)
Condition variables
(C++11)
Futures
(C++11)
(C++11)
(C++11)
(C++11)
 
 
void set_exception( std::exception_ptr p );
(since C++11)

Stores the exception pointer p into the shared state and makes the state ready.

The operation is atomic, i.e. it behaves as though they acquire a single mutex associated with the promise object while updating the promise object.

An exception is thrown if there is no shared state or the shared state already stores a value or exception.

Contents

Parameters

p - exception pointer to store

Return value

(none)

Exceptions

std::future_error on the following conditions:

  • *this has no shared state. The error category is set to no_state.

Example

#include <thread>
#include <iostream>
#include <future>
 
int main()
{
    std::promise<int> result;
 
    std::thread t([&]{
            try {
                // code that may throw
                throw std::runtime_error("Example");
            } catch(...) {
                try {
                    // store anything thrown in the promise
                    result.set_exception(std::current_exception());
                } catch(...) {} // set_exception() may throw too
            }
    });
 
    try {
        std::cout << result.get_future().get();
    } catch(const std::exception& e) {
        std::cout << "Exception from the thread: " << e.what() << '\n';
    }
    t.join();
}

Output:

Exception from the thread: Example

See also

sets the result to indicate an exception while delivering the notification only at thread exit
(public member function) [edit]